package com.sidlee.as3lib.modules.copy
{
	import com.sidlee.as3lib.modules.copy.datasources.ICopyModuleDataSource;
	
	import flash.errors.IllegalOperationError;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	
	/**
	 * @author Antti Kupila
	 */
	public class CopyModule extends EventDispatcher implements ICopyModule
	{
		
		//---------------------------------------------------------------------
		//
		//  Constants
		//
		//---------------------------------------------------------------------
		
		
		
		
		//---------------------------------------------------------------------
		//
		//  Variables
		//
		//---------------------------------------------------------------------
		
		private var copy:Object;
		private var datasource:ICopyModuleDataSource;
		
		
		//---------------------------------------------------------------------
		//
		//  Constructor
		//
		//---------------------------------------------------------------------
		
		public function CopyModule(datasource:ICopyModuleDataSource)
		{
			super();
			
			this.datasource = datasource;
		}
		
		
		//---------------------------------------------------------------------
		//
		//  Events
		//
		//---------------------------------------------------------------------
		
		private function copyLoadHandler(event:Event):void
		{
			copy = datasource.getCopy();
			dispatchEvent(new Event(Event.COMPLETE));
		}
		
		
		//---------------------------------------------------------------------
		//
		//  Public API
		//
		//---------------------------------------------------------------------
		
		public function load(... args):void
		{
			datasource.addEventListener(Event.COMPLETE, copyLoadHandler);
			datasource.loadCopy(args);
		}
		
		public function getCopy(key:String):String
		{
			if(!copy)
				throw new IllegalOperationError("CopyModule not loaded. Call copyModel.load() first");
			return copy[key] || "?" + key + "?";
		}
		
		public function printCopyList():String
		{
			var str:String = "Available copy:";
			for(var key:String in copy)
			{
				str += "\n  " + key + "  =  " + copy[key];
			}
			return str;
		}
	}
}
