package com.sidlee.as3lib.modules.copy.datasources
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	/**
	 * @author Antti Kupila
	 */
	public class AbstractCopyXMLDataSource extends EventDispatcher
	{
		
		//---------------------------------------------------------------------
		//
		//  Variables
		//
		//---------------------------------------------------------------------
		
		private var filename:String;
		private var parsedCopy:Object;
		
		private var urlLoader:URLLoader;
		
		
		//---------------------------------------------------------------------
		//
		//  Constructor
		//
		//---------------------------------------------------------------------
		
		public function AbstractCopyXMLDataSource(filename:String)
		{
			super();
			
			this.filename = filename;
		}
		
		
		//---------------------------------------------------------------------
		//
		//  Protected methods
		//
		//---------------------------------------------------------------------
		
		protected function processXML(source:XML):void
		{
			throw new Error("AbstractXMLDataSource::processXML must be overriden");
		}
		
		protected function parse(response:XMLList, keySource:String, valueSource:String):void
		{
			parsedCopy = {};
			for each(var node:XML in response)
			{
				var k:String = node[keySource];
				var v:String = (valueSource && valueSource.length > 0) ? node[valueSource].toString() : node.toString();
				parsedCopy[k] = v;
			}
			dispatchEvent(new Event(Event.COMPLETE));
		}
		
		
		//---------------------------------------------------------------------
		//
		//  Events
		//
		//---------------------------------------------------------------------
		
		final protected function loadHandler(event:Event):void
		{
			processXML(new XML(urlLoader.data));
		}
		
		
		//---------------------------------------------------------------------
		//
		//  Public API
		//
		//---------------------------------------------------------------------
		
		public function loadCopy(... args):void
		{
			urlLoader = new URLLoader();
			urlLoader.addEventListener(Event.COMPLETE, loadHandler);
			urlLoader.load(new URLRequest(filename));
		}
		
		public function getCopy():Object
		{
			return parsedCopy;
		}
	}
}
