package com.sidlee.as3lib.modules.copy.datasources
{
	import com.sidlee.as3lib.modules.copy.datasources.ICopyModuleDataSource;
	import com.sidlee.as3lib.modules.webservice.AdidasWebservice;
	import com.sidlee.as3lib.modules.webservice.IWebservice;
	import com.sidlee.as3lib.modules.webservice.WebserviceResponse;
	
	import flash.events.Event;
	import flash.events.EventDispatcher;
	
	/**
	 * @author Antti Kupila
	 */
	public class CID extends EventDispatcher implements ICopyModuleDataSource
	{
		
		//---------------------------------------------------------------------
		//
		//  Variables
		//
		//---------------------------------------------------------------------
		
		private var webservice:IWebservice;
		private var parsedCopy:Object;
		
		private var args:Array;
		
		
		//---------------------------------------------------------------------
		//
		//  Constructor
		//
		//---------------------------------------------------------------------
		
		public function CID(webservice:IWebservice)
		{
			super();
			
			this.webservice = webservice;
		}
		
		
		//---------------------------------------------------------------------
		//
		//  Events
		//
		//---------------------------------------------------------------------
		
		private function webserviceConnectedHandler(event:Event):void
		{
			loadCopy.apply(this, args);
		}
		
		private function copyLoadHandler(response:XML):void
		{
			if(response.Message.@HasError != "false")
			{
				throw new Error(response.Message.@ErrorDescription);
			}
			else
			{
				parsedCopy = {};
				for each(var node:XML in response.ResourceItem.ResourceItem)
				{
					parsedCopy[node.@Key] = node.Value.text();
				}
				
				dispatchEvent(new Event(Event.COMPLETE));
			}
		}
		
		
		//---------------------------------------------------------------------
		//
		//  Public API
		//
		//---------------------------------------------------------------------
		
		public function loadCopy(... args):void
		{
			if(args.length <= 0)
				args = ["com"];
			this.args = args;
			if(!webservice.isConnected)
			{
				webservice.addEventListener("webserviceConnected", webserviceConnectedHandler); // don't use constant from AdidasWebservice to avoid coupling..
				webservice.connect();
			}
			else
			{
				webservice.callMethod("GetResourceItemList", WebserviceResponse.createResponse(copyLoadHandler), args[0]);
			}
		}
		
		public function getCopy():Object
		{
			return parsedCopy;
		}
	}
}
