package com.sidlee.as3lib.modules.copy.datasources
{
	import com.sidlee.as3lib.modules.copy.datasources.ICopyModuleDataSource;
	import com.sidlee.as3lib.modules.webservice.WebserviceResponse;
	
	/**
	 * @author Antti Kupila
	 */
	public class CIDXmlDataSource extends AbstractCopyXMLDataSource implements ICopyModuleDataSource
	{
		
		
		//---------------------------------------------------------------------
		//
		//  Constructor
		//
		//---------------------------------------------------------------------
		
		public function CIDXmlDataSource(filename:String)
		{
			super(filename);
		}
		
		
		//---------------------------------------------------------------------
		//
		//  Protected methods
		//
		//---------------------------------------------------------------------
		
		override protected function processXML(response:XML):void
		{
			var wsResponse:Function = WebserviceResponse.createResponse(parseComplete);
			wsResponse(new XML(response));
		}
		
		protected function parseComplete(response:XML):void
		{
			if(response.Message.@HasError != "false")
			{
				throw new Error(response.Message.@ErrorDescription);
			}
			else
			{
				parse(response.ResourceItem.ResourceItem, "@Key", "Value");
			}
		}
	
	}
}
