package net.jansensan.robotlegstest
{
	// + ----------------------------------------
	//		[ IMPORTS ]
	// + ----------------------------------------
	
	import net.jansensan.robotlegstest.controller.*;
	import net.jansensan.robotlegstest.events.*;
	import net.jansensan.robotlegstest.model.AppModel;
	import net.jansensan.robotlegstest.model.AssetsModel;
	import net.jansensan.robotlegstest.model.ConfigModel;
	import net.jansensan.robotlegstest.model.StateModel;
	import net.jansensan.robotlegstest.view.*;
	import net.jansensan.robotlegstest.view.pages.SelectImageMediator;
	import net.jansensan.robotlegstest.view.pages.SelectImagePage;
	import net.jansensan.robotlegstest.view.preloader.*;
	
	import flash.display.DisplayObjectContainer;
	
	import org.robotlegs.base.ContextEvent;
	import org.robotlegs.mvcs.Context;
	
	
	/**
	 * @author Mat Janson Blanchet
	 */
	public class RobotLegsTestContext extends Context
	{
		// + ----------------------------------------
		//		[CONSTRUCTOR ]
		// + ----------------------------------------
		
		public function RobotLegsTestContext	(	contextView:DisplayObjectContainer = null,
													autoStartup:Boolean = true
											)
		{
			super(contextView, autoStartup);
		}
		
		
		// + ----------------------------------------
		//		[ PUBLIC METHODS ]
		// + ----------------------------------------
		
		override public function startup():void
		{
			// controller / commands
			commandMap.mapEvent	(	ContextEvent.STARTUP_COMPLETE,
									AddRootViewCommand,
									ContextEvent,
									true
								);
			commandMap.mapEvent	(	RobotLegsTestEvent.ROOT_VIEW_ADDED,
									LoadConfigCommand,
									RobotLegsTestEvent,
									true
								);
			commandMap.mapEvent	(	RobotLegsTestEvent.CONFIG_MODEL_READY,
									LoadAssetsCommand,
									RobotLegsTestEvent,
									true
								);
			commandMap.mapEvent	(	RobotLegsTestEvent.PRELOADER_ANIM_COMPLETE,
									InitApplicationCommand,
									RobotLegsTestEvent,
									true
								);
			commandMap.mapEvent	(	RobotLegsTestEvent.BASIC_UI_ADDED,
									AddPagesCommand,
									RobotLegsTestEvent,
									true
								);
			
			// model
			injector.mapSingleton(AppModel);
			injector.mapSingleton(ConfigModel);
			injector.mapSingleton(AssetsModel);
			injector.mapSingleton(StateModel);
			
			// view
			mediatorMap.mapView(RootView, RootMediator);
			mediatorMap.mapView(PreloaderView, PreloaderMediator);
		//	mediatorMap.mapView(SelectImagePage, SelectImageMediator);
			
			// startup
			super.startup();
		}
		
		
	}
}