package net.jansensan.robotlegstest.events
{
	// + ----------------------------------------
	//		[ IMPORTS ]
	// + ----------------------------------------
	
	import flash.events.Event;
	
	
	/**
	 * @author Mat Janson Blanchet
	 */
	public class RobotLegsTestEvent extends Event
	{
		// + ----------------------------------------
		//		[ CONSTANTS ]
		// + ----------------------------------------
		
		public	static	const	ROOT_VIEW_ADDED			:String = "ROOT_VIEW_ADDED";
		public	static	const	CONFIG_MODEL_READY		:String = "CONFIG_MODEL_READY";
		public	static	const	ASSETS_LOAD_PROGRESS	:String = "ASSETS_LOAD_PROGRESS";
		public	static	const	ASSETS_LOAD_COMPLETE	:String = "ASSETS_LOAD_COMPLETE";
		public	static	const	PRELOADER_ANIM_COMPLETE	:String = "PRELOADER_ANIM_COMPLETE";
		public	static	const	BASIC_UI_ADDED			:String = "BASIC_UI_ADDED";
		public	static	const	STATE_CHANGE			:String = "STATE_CHANGE";
		public	static	const	BACK_BUTTON_CLICK		:String = "BACK_BUTTON_CLICK";
		public	static	const	CONTINUE_BUTTON_CLICK	:String = "CONTINUE_BUTTON_CLICK";
		
		
		// + ----------------------------------------
		//		[ VARIABLES ]
		// + ----------------------------------------
		
		private	var	_data	:Object;
		
		
		// + ----------------------------------------
		//		[CONSTRUCTOR ]
		// + ----------------------------------------
		
		public function RobotLegsTestEvent	(	type:String,
													bubbles:Boolean = false,
													cancelable:Boolean = false,
													data:Object = null
												)
		{
			super(type, bubbles, cancelable);
			_data = data;
		}
		
		
		// + ----------------------------------------
		//		[ PUBLIC METHODS ]
		// + ----------------------------------------
		
		public override function clone():Event
		{
			return new RobotLegsTestEvent(type, bubbles, cancelable, _data);
		}
		
		
		
		// + ----------------------------------------
		//		[ GETTERS / SETTERS ]
		// + ----------------------------------------
		
		public function get data():Object
		{
			return _data
		}
		
		
		public function set data(value:Object):void
		{
			_data = data;
		}
		
		
	}
}