package net.jansensan.robotlegstest.model
{
	// + ----------------------------------------
	//		[ IMPORTS ]
	// + ----------------------------------------
	
	import org.robotlegs.mvcs.Actor;
	
	
	/**
	 * @author Mat Janson Blanchet
	 */
	public class AppModel extends Actor
	{
		// + ----------------------------------------
		//		[ CONSTANTS ]
		// + ----------------------------------------
		
		public	static	const	WIDTH	:uint = 520;
		public	static	const	HEIGHT	:uint = 600;
		
		
		// + ----------------------------------------
		//		[ VARIABLES ]
		// + ----------------------------------------
		
		private	var	_HTMLVars		:Object;
		private	var	_numHTMLVars	:uint = 0;
		
		
		// + ----------------------------------------
		//		[CONSTRUCTOR ]
		// + ----------------------------------------
		
		public function AppModel()
		{
			super();
		}
		
		
		// + ----------------------------------------
		//		[ PUBLIC METHODS ]
		// + ----------------------------------------
		
		public function getAppWidth():uint
		{
			return WIDTH;
		}
		
		
		public function getAppHeight():uint
		{
			return HEIGHT;
		}
		
		
		public function setHTMLVars(HTMLVars:Object, traceVars:Boolean = false):void
		{
			if(traceVars) trace("\n", this, "--- setHTMLVars ---");
			_HTMLVars = HTMLVars;
			for(var varName:String in _HTMLVars)
			{
				if(traceVars) trace(varName + ": " + _HTMLVars[varName]);
				_numHTMLVars++;
			}
		}
		
		
		public function getHTMLVarByName(varName:String):*
		{
			return _HTMLVars[varName];
		}
		
		
		// + ----------------------------------------
		//		[ PUBLIC METHODS ]
		// + ----------------------------------------
		
		public function get numHTMLVars():uint
		{
			return _numHTMLVars;
		}
		
		
	}
}