package net.jansensan.robotlegstest.model
{
	// + ----------------------------------------
	//		[ IMPORTS ]
	// + ----------------------------------------
	
	import net.jansensan.robotlegstest.events.RobotLegsTestEvent;
	
	import flash.events.Event;
	
	import net.jansensan.loaders.AuthoringAssetsLoader;
	import net.jansensan.loaders.CSSLoader;
	import net.jansensan.loaders.SWFFontsLoader;
	import net.jansensan.loaders.XMLLoader;
	
	import org.robotlegs.mvcs.Actor;
	
	
	/**
	 * <p>Contains the information obtained in the config XML file.</p>
	 * 
	 * @author Mat Janson Blanchet
	 */
	public class ConfigModel extends Actor
	{
		// + ----------------------------------------
		//		[ VARIABLES ]
		// + ----------------------------------------
		
		[Inject]
		public	var	appModel				:AppModel;
		
		private	var	_baseURL				:String;
		
		private	var	_XMLURL					:String;
		private	var	_XMLLoader				:XMLLoader;
		private	var	_XMLData				:XML;

		private	var	_currentCountry			:String = "com";
		private	var	_currentLanguage		:String = "en";
		private	var	_currentAlphabet		:String = "latin";

		private	var	_assetsDirectoryURL		:String;
		private	var	_authoringAssetsSWFURL	:String;
		private	var	_soundAssetsSWFURL		:String;
		private	var	_fontsSWFURL			:String;
		private	var	_CSSURL					:String;
		
		
		// + ----------------------------------------
		//		[CONSTRUCTOR ]
		// + ----------------------------------------
		
		public function ConfigModel()
		{
			super();
		}
		
		
		// + ----------------------------------------
		//		[ PUBLIC METHODS ]
		// + ----------------------------------------
		
		public function loadConfigXML():void
		{
			_XMLURL = (appModel.numHTMLVars == 0) ? "../assets/xml/config.xml" : "assets/xml/config.xml";
			_XMLLoader = new XMLLoader();
			_XMLLoader.addEventListener(XMLLoader.READY, XMLLoaderReadyHandler, false, 0, true);
			_XMLLoader.load(_XMLURL);
		}
		
		
		// + ----------------------------------------
		//		[ PRIVATE/PROTECTED METHODS ]
		// + ----------------------------------------
		
		private function parseXML(XMLData:XML):void
		{
			_XMLData = XMLData;
			
			_assetsDirectoryURL = _XMLData.assets.assetsDirectory.@url;
			_authoringAssetsSWFURL = _assetsDirectoryURL + _XMLData.assets.authoringAssets.@url;
			_CSSURL = _assetsDirectoryURL + _XMLData.assets.css.alphabet.(@alphabet == _currentAlphabet).@url;
			/*
			_soundAssetsSWFURL = _assetsDirectoryURL + _XMLData.assets.soundAssets.@url;
			_fontsSWFURL = _assetsDirectoryURL + _XMLData.assets.fonts.alphabet.(@alphabet == _currentAlphabet).@url;
			*/
			
			eventDispatcher.dispatchEvent(new RobotLegsTestEvent(RobotLegsTestEvent.CONFIG_MODEL_READY));
		}
		
		
		// + ----------------------------------------
		//		[ EVENT HANDLERS ]
		// + ----------------------------------------
		
		private function XMLLoaderReadyHandler(event:Event):void
		{
			_XMLLoader.removeEventListener(XMLLoader.READY, XMLLoaderReadyHandler);
			parseXML(_XMLLoader.XMLData);
		}
		
		
		// + ----------------------------------------
		//		[ GETTERS / SETTERS ]
		// + ----------------------------------------
		
		public function get assetsDirectoryURL():String
		{
			return _assetsDirectoryURL;
		}
		
		
		public function get authoringAssetsSWFURL():String
		{
			return _authoringAssetsSWFURL;
		}
		
		
		public function get CSSURL():String
		{
			return _CSSURL;
		}
		
		
	}
}