package net.jansensan.robotlegstest.model
{
	// + ----------------------------------------
	//		[ IMPORTS ]
	// + ----------------------------------------
	
	import net.jansensan.robotlegstest.events.RobotLegsTestEvent;
	
	import org.robotlegs.mvcs.Actor;
	
	
	/**
	 * @author Mat Janson Blanchet
	 */
	public class StateModel extends Actor
	{
		// + ----------------------------------------
		//		[ VARIABLES ]
		// + ----------------------------------------
		
		private	var	_state	:String;
		
		
		// + ----------------------------------------
		//		[CONSTRUCTOR ]
		// + ----------------------------------------
		
		public function StateModel()
		{
			super();
			_state = StateModelState.PRELOADING;
		}
		
		
		// + ----------------------------------------
		//		[ PRIVATE/PROTECTED METHODS ]
		// + ----------------------------------------
		
		private function setState(newState:String):void
		{
			switch(newState)
			{
				case StateModelState.PRELOADING:
				case StateModelState.INITIALIZING:
				case StateModelState.SELECT_IMAGE_PAGE:
				case StateModelState.CROP_IMAGE_PAGE:
				case StateModelState.CRYSTALLIZE_IMAGE_PAGE:
				case StateModelState.INSTRUCTIONS_PAGE:
				case StateModelState.THANKS_PAGE:
				case StateModelState.IN_TRANSITION:
					_state = newState;
					dispatch(new RobotLegsTestEvent(RobotLegsTestEvent.STATE_CHANGE));
					break;
				
				default :
					var error:Error = new Error("The new state set to the StateModel (" + newState + ") is not supported. See the StateModelState class to know what states are available.");
					throw error;
					break;
			}
		}
		
		
		// + ----------------------------------------
		//		[ GETTERS / SETTERS ]
		// + ----------------------------------------
		
		public function set state(value:String):void
		{
			setState(value);
		}
		
		
		public function get state():String
		{
			return _state;
		}
		
		
	}
}