package net.jansensan.robotlegstest.view
{
	// + ----------------------------------------
	//		[ IMPORTS ]
	// + ----------------------------------------
	
	import net.jansensan.robotlegstest.events.RobotLegsTestEvent;
	import net.jansensan.robotlegstest.model.AppModel;
	import net.jansensan.robotlegstest.model.StateModel;
	import net.jansensan.robotlegstest.model.StateModelState;
	
	import org.robotlegs.mvcs.Mediator;
	
	
	/**
	 * @author Mat Janson Blanchet
	 */
	public class RootMediator extends Mediator
	{
		// + ----------------------------------------
		//		[ VARIABLES ]
		// + ----------------------------------------
		
		[Inject]
		public	var	appModel	:AppModel;
		
		[Inject]
		public	var	stateModel	:StateModel;
		
		[Inject]
		public	var	view		:RootView;
		
		
		// + ----------------------------------------
		//		[CONSTRUCTOR ]
		// + ----------------------------------------
		
		public function RootMediator()
		{
			super();
		}
		
		
		// + ----------------------------------------
		//		[ PUBLIC METHODS ]
		// + ----------------------------------------
		
		override public function onRegister():void
		{
			eventMap.mapListener	(	eventDispatcher,
										RobotLegsTestEvent.STATE_CHANGE,
										stateChangeHandler,
										RobotLegsTestEvent
									);
			eventMap.mapListener	(	view,
										RobotLegsTestEvent.BASIC_UI_ADDED,
										basicUIAddedHandler,
										RobotLegsTestEvent
									);
			
			appModel.setHTMLVars(view.stage.loaderInfo.parameters, true);
			
			view.init();
			view.resize(appModel.getAppWidth(), appModel.getAppHeight());
			
			dispatch(new RobotLegsTestEvent(RobotLegsTestEvent.ROOT_VIEW_ADDED));
		}
		
		// + ----------------------------------------
		//		[ EVENT HANDLERS ]
		// + ----------------------------------------
		
		private function stateChangeHandler(event:RobotLegsTestEvent):void
		{
			switch(stateModel.state)
			{
				case StateModelState.INITIALIZING:
					view.addBasicUI();
					break;
			}
		}
		
		
		private function basicUIAddedHandler(event:RobotLegsTestEvent):void
		{
			trace("\n", this, "--- basicUIAddedHandler ---");
			
			/*
			eventDispatcher.dispatchEvent(event);
			eventMap.unmapListener	(	view,
										ReflectYourselfEvent.BASIC_UI_ADDED,
										basicUIAddedHandler,
										ReflectYourselfEvent
									);
			*/
			
			dispatch(new RobotLegsTestEvent(RobotLegsTestEvent.BASIC_UI_ADDED));
		}
		
		
	}
}