package net.jansensan.robotlegstest.view.pages
{
	// + ----------------------------------------
	//		[ IMPORTS ]
	// + ----------------------------------------
	
	import net.jansensan.robotlegstest.events.RobotLegsTestEvent;
	import net.jansensan.robotlegstest.model.AppModel;
	
	import org.robotlegs.mvcs.Mediator;
	
	
	/**
	 * @author Mat Janson Blanchet
	 */
	public class SelectImageMediator extends Mediator
	{
		// + ----------------------------------------
		//		[ VARIABLES ]
		// + ----------------------------------------
		
		[Inject]
		public	var	appModel	:AppModel;
		
		[Inject]
		public	var	view		:SelectImagePage;
		
		
		// + ----------------------------------------
		//		[CONSTRUCTOR ]
		// + ----------------------------------------
		
		public function SelectImageMediator()
		{
			super();
		}
		
		
		// + ----------------------------------------
		//		[ PUBLIC METHODS ]
		// + ----------------------------------------
		
		override public function onRegister():void
		{
			trace("\n", this, "--- onRegister ---");
			
			view.useProfilePicButtonLabel = "USE MY PROFILE PICTURE";
			view.useWebcamButtonLabel = "USE MY WEBCAM";
			view.takePicButtonLabel = "TAKE SNAPSHOT";
			view.resetWebcamButtonLabel = "TRY AGAIN";
			view.backButtonLabel = "BACK";
			view.continueButtonLabel = "CONTINUE";
			view.init();
			view.resize(appModel.getAppWidth(), appModel.getAppHeight());
			
			eventMap.mapListener	(	view,
										RobotLegsTestEvent.BACK_BUTTON_CLICK,
										backButtonClickHandler,
										RobotLegsTestEvent
									);
			eventMap.mapListener	(	view,
										RobotLegsTestEvent.CONTINUE_BUTTON_CLICK,
										continueButtonClickHandler,
										RobotLegsTestEvent
									);
		}
		
		
		// + ----------------------------------------
		//		[ EVENT HANDLERS ]
		// + ----------------------------------------
		
		private function backButtonClickHandler(event:RobotLegsTestEvent):void
		{
			
		}
		
		
		private function continueButtonClickHandler(event:RobotLegsTestEvent):void
		{
			
		}
		
		
	}
}