package net.jansensan.robotlegstest.view.pages
{
	// + ----------------------------------------
	//		[ IMPORTS ]
	// + ----------------------------------------
	
	import com.sidlee.as3mvc.view.IView;
	
	import flash.display.MovieClip;
	import flash.display.Sprite;
	
	
	/**
	 * @author Mat Janson Blanchet
	 */
	public class SelectImagePage extends Sprite implements IView
	{
		// + ----------------------------------------
		//		[ VARIABLES ]
		// + ----------------------------------------
		
		private	const	BUTTON_WIDTH	:uint = 151;
		
		
		// + ----------------------------------------
		//		[ VARIABLES ]
		// + ----------------------------------------
		
		public	var	useProfilePicButtonLabel	:String;
		public	var	useWebcamButtonLabel		:String;
		public	var	takePicButtonLabel			:String;
		public	var	resetWebcamButtonLabel		:String;
		public	var	backButtonLabel				:String;
		public	var	continueButtonLabel			:String;
		
		private	var	_width						:int;
		private	var	_height						:int;
		
		/*
		private	var	_useProfilePicButton		:MovieClip	// ButtonAsset;
		private	var	_useWebcamButton			:MovieClip	// ButtonAsset;
		private	var	_imageHolder				:MovieClip	// ImageFrameAsset;
		private	var	_takePicButton				:MovieClip	// ButtonAsset;
		private	var	_continueButton				:MovieClip	// ButtonAsset;
		*/
		
		private	var	_useProfilePicButton		:ButtonAsset;
		private	var	_useWebcamButton			:ButtonAsset;
		private	var	_imageHolder				:ImageFrameAsset;
		private	var	_takePicButton				:ButtonAsset;
		private	var	_continueButton				:ButtonAsset;
		
		
		// + ----------------------------------------
		//		[CONSTRUCTOR ]
		// + ----------------------------------------
		
		public function SelectImagePage()
		{
			trace("\n", this, "--- constructor ---");
			
			super();
		}
		
		
		// + ----------------------------------------
		//		[ PUBLIC METHODS ]
		// + ----------------------------------------
		
		public function init():void
		{
			trace("\n", this, "--- init ---");
			
			_useProfilePicButton = new ButtonAsset();
			_useProfilePicButton.width = BUTTON_WIDTH;
			_useProfilePicButton.labelTXT.htmlText = useProfilePicButtonLabel;
			_useProfilePicButton.buttonMode = true;
			
			_useWebcamButton = new ButtonAsset();
			_useWebcamButton.width = BUTTON_WIDTH;
			_useWebcamButton.labelTXT.htmlText = useWebcamButtonLabel;
			_useWebcamButton.buttonMode = true;
			
			_imageHolder = new ImageFrameAsset();
			
			_takePicButton = new ButtonAsset();
			_takePicButton.width = BUTTON_WIDTH;
			_takePicButton.labelTXT.htmlText = takePicButtonLabel;
			_takePicButton.useHandCursor = true;
			
			_continueButton = new ButtonAsset();
			_continueButton.width = BUTTON_WIDTH;
			_continueButton.labelTXT.htmlText = continueButtonLabel;
			_continueButton.buttonMode = true;
			
			addChild(_useProfilePicButton);
			addChild(_useWebcamButton);
			addChild(_imageHolder);
			addChild(_continueButton);
		}
		
		
		public function resize(newWidth:int, newHeight:int):void
		{
			_width = newWidth;
			_height = newHeight;
			
			_useProfilePicButton.y = 177;
			_useProfilePicButton.x = _width * 0.5 - BUTTON_WIDTH - 5;
			
			_useWebcamButton.y = _useProfilePicButton.y;
			_useWebcamButton.x = _width * 0.5 + 5;
			
			_imageHolder.x = int(_width * 0.5 -_imageHolder.width * 0.5);
			_imageHolder.y = 208;
			
			_takePicButton.width = _imageHolder.width;
			_takePicButton.x = int(_width * 0.5 - BUTTON_WIDTH * 0.5);
			_takePicButton.y = _imageHolder.y + _imageHolder.height + 18;
			
			_continueButton.x = int(_width * 0.5 - BUTTON_WIDTH * 0.5);
			_continueButton.y = 543;
		}
		
		
		public function show():void
		{
			
		}
		
		
		public function hide():void
		{
			
		}
		
		
		public function kill():void
		{
			
		}
		
		
	}
}