package net.jansensan.robotlegstest.view.preloader
{
	// + ----------------------------------------
	//		[ IMPORTS ]
	// + ----------------------------------------
	
	import net.jansensan.robotlegstest.events.RobotLegsTestEvent;
	import net.jansensan.robotlegstest.model.AssetsModel;
	
	import flash.events.Event;
	
	import org.robotlegs.mvcs.Mediator;
	
	
	/**
	 * @author Mat Janson Blanchet
	 */
	public class PreloaderMediator extends Mediator
	{
		// + ----------------------------------------
		//		[ VARIABLES ]
		// + ----------------------------------------
		
		[Inject]
		public	var	assetsModel	:AssetsModel;
		
		[Inject]
		public	var	view		:PreloaderView;
		
		
		// + ----------------------------------------
		//		[CONSTRUCTOR ]
		// + ----------------------------------------
		
		public function PreloaderMediator()
		{
			super();
		}
		
		
		// + ----------------------------------------
		//		[ PUBLIC METHODS ]
		// + ----------------------------------------
		
		override public function onRegister():void
		{
			view.init();
			
			eventMap.mapListener	(	view,
										Event.COMPLETE,
										loadingAnimCompleteHandler,
										Event
									);
			
			eventMap.mapListener	(	eventDispatcher,
										RobotLegsTestEvent.ASSETS_LOAD_PROGRESS,
										assetsLoadProgressHandler,
										RobotLegsTestEvent
									);
		}
		
		
		// + ----------------------------------------
		//		[ EVENT HANDLERS ]
		// + ----------------------------------------
		
		private function assetsLoadProgressHandler(event:RobotLegsTestEvent):void
		{
			view.setLoadingRatio(assetsModel.loadedRatio);
		}
		
		
		private function loadingAnimCompleteHandler(event:Event):void
		{
			eventMap.unmapListener	(	view,
										Event.COMPLETE,
										loadingAnimCompleteHandler,
										Event
									);
			view.hide();
			eventDispatcher.dispatchEvent(new RobotLegsTestEvent(RobotLegsTestEvent.PRELOADER_ANIM_COMPLETE));
		}
		
		
	}
}