package net.jansensan.robotlegstest.view.preloader
{
	// + ----------------------------------------
	//		[ IMPORTS ]
	// + ----------------------------------------
	
	import com.greensock.TweenMax;
	import com.sidlee.as3mvc.events.ViewEvent;
	import com.sidlee.as3mvc.view.IView;
	
	import flash.display.Sprite;
	import flash.events.Event;
	
	
	/**
	 * @author Mat Janson Blanchet
	 */
	public class PreloaderView extends Sprite implements IView
	{
		// + ----------------------------------------
		//		[ CONSTANT ]
		// + ----------------------------------------
		
		private	const	PROGRESS_BAR_WIDTH	:uint = 121;
		private	const	PROGRESS_BAR_HEIGHT	:uint = 19;
		
		
		// + ----------------------------------------
		//		[ VARIABLES ]
		// + ----------------------------------------
		
		private	var	_progressBar	:PreloaderBarAsset;
		private	var	_width			:int;
		private	var	_height			:int;
		
		
		// + ----------------------------------------
		//		[CONSTRUCTOR ]
		// + ----------------------------------------
		
		public function PreloaderView()
		{
			super();
		}
		
		
		// + ----------------------------------------
		//		[ PUBLIC METHODS ]
		// + ----------------------------------------
		
		public function init():void
		{
			_progressBar = new PreloaderBarAsset();
			addChild(_progressBar);
			reset();
		}
		
		
		public function resize(newWidth:int, newHeight:int):void
		{
			_width = newWidth;
			_height = newHeight;
			
			if(_progressBar)
			{
				_progressBar.x = int(_width * 0.5 - PROGRESS_BAR_WIDTH * 0.5);
				_progressBar.y = int(_height * 0.5 - PROGRESS_BAR_HEIGHT * 0.5);
			}
		}
		
		
		public function setLoadingRatio(ratio:Number):void
		{
			var percentage:String = int(ratio * 100) + "%";
			var widthTo:int = ratio * PROGRESS_BAR_WIDTH;
			var onCompleteFunction:Function = (ratio == 1) ? dispatchAnimComplete : null;
			TweenMax.to(_progressBar.fillMC, 0.35, {width:widthTo, onComplete:onCompleteFunction});
			_progressBar.labelTXT.text = percentage;
		}
		
		
		public function reset():void
		{
			_progressBar.fillMC.width = 0;
		}
		
		
		public function show():void
		{
			visible = true;
			showComplete();
		}
		
		
		public function hide():void
		{
			visible = false;
			hideComplete();
		}
		
		
		public function kill():void
		{
			
		}
		
		
		// + ----------------------------------------
		//		[ PRIVATE/PROTECTED METHODS ]
		// + ----------------------------------------
		
		private function showComplete():void
		{
			dispatchEvent(new ViewEvent(ViewEvent.SHOW_COMPLETE));
		}
		
		
		private function hideComplete():void
		{
			dispatchEvent(new ViewEvent(ViewEvent.HIDE_COMPLETE));
		}
		
		
		private function dispatchAnimComplete():void
		{
			dispatchEvent(new Event(Event.COMPLETE));
		}
		
		
	}
}